﻿package
{
	import flash.display.Sprite;
	import flash.display.GradientType;
	import flash.events.Event;
	import flash.utils.setInterval;
	import flash.filters.BlurFilter;
	import flash.display.SpreadMethod;
	import flash.geom.Matrix;
	import flash.events.MouseEvent;
	import flash.events.KeyboardEvent;

	public class Genever extends Sprite
	{
		private var points:Array = new Array();
		private var numPoints:Number = 100;
		private var gravity:Number = 0.06;
		private var blurFilter:BlurFilter = new BlurFilter();
		private var fillType:String = GradientType.RADIAL;
		private var spreadMethod:String = SpreadMethod.REFLECT;
		private var colors:Array = [0x000000,0x009C58];
		private var alphas:Array = [1,1];
		private var ratios:Array = [100,255];
		private var matr:Matrix = new Matrix();
		
		public function Genever()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			addEventListener(Event.ENTER_FRAME,enterHandler);
			
		}
		private function enterHandler(e:Event):void
		{
			addPoint();
			update();
			draw();
			this.addEventListener(MouseEvent.MOUSE_OVER, colorChanger);
			this.addEventListener(MouseEvent.MOUSE_DOWN, eraseHandler);
		}
		
		private function eraseHandler(e:MouseEvent):void{
				//trace("OVER");
				graphics.clear();			
		}
		
		private function colorChanger(e:MouseEvent):void{
			//trace("CLIK");
			colors = [0x000000,Math.random()*0xFFFFFF]
			//this.graphics.lineStyle(1,Math.random()*0x000000,.1);
			//this.graphics.clear();
			
		}
		private function addPoint():void
		{
			var point:Object;
			if(points.length<numPoints){
			point = {};
			initPoint(point);
			points.push(point);
			}
		}
		private function initPoint(p:Object):void
		{
			p.x = stage.stageWidth/2;
			p.y = stage.stageHeight;
			p.vx = Math.random()*4-2;
			p.vy = Math.random()*-6-5;
			p.radius = Math.random()*10+1;
		}
		private function update():void
		{
			for(var i:Number = 0;i< points.length;i++){
				points[i].vy += gravity;
				points[i].x += points[i].vx;
				points[i].y+= points[i].vy;
				if(points[i].x>stage.stageWidth  || points[i].x < 0 || points[i].y >stage.stageHeight || points[i].y < 0){
					initPoint(points[i]);
				}
			}
		}
		private function draw():void
		{
			//this.graphics.clear();
			blurFilter.blurX = 5;
			blurFilter.blurY = 5;
			blurFilter.quality = 5;
			
			for(var i:Number = 0;i<points.length;i++){
				matr.createGradientBox(30,30,10,0,0);
				this.graphics.beginGradientFill(fillType,colors,alphas,ratios,matr,spreadMethod);
				//this.graphics.lineStyle(1,0xffffff,.1);
				//this.graphics.beginFill(0xff0000,.1);
				this.graphics.drawCircle(points[i].x,points[i].y,points[i].radius);
				this.graphics.endFill();
				filters = [blurFilter];
							}
		}
	}
}